//
//  AddInputViewController.swift
//  MeasurementHelper
//
//  Created by Carlos Barrera on 18/11/17.
//  Copyright © 2017 Carlos Barrera. All rights reserved.
//

import UIKit

class AddInputViewController: UIViewController {

    
    enum constants : String{
        case unwindSegueIdentifier = "unwindToExperimentDataInputOutputWithSenderIdentifier"
    }

    @IBOutlet weak var var1Label: UILabel!
    @IBOutlet weak var var1Field: UITextField!
    @IBOutlet weak var var1UnitsLabel: UILabel!
    
    // Hidden by default
    @IBOutlet weak var var2Label: UILabel!
    @IBOutlet weak var var2Field: UITextField!
    @IBOutlet weak var var2UnitsLabel: UILabel!
    
    var inputList : [Input]?
    var variables : [Variable]?
    var appDelegate : AppDelegate?

    override func viewDidLoad() {
        super.viewDidLoad()
        appDelegate = (UIApplication.shared.delegate as! AppDelegate)
        loadFromDelegate()

        self.initUI()
        
        // Do any additional setup after loading the view.
    }
    
    func initUI(){
        if variables?.count == 2 {
            self.var2Label.isHidden = false
            self.var2Field.isHidden = false
            self.var2UnitsLabel.isHidden = false
            let var2 = self.variables?[1]
            self.var1Label.text = var2?.label.description
            self.var1Field.text = 0.0.description
            switch var2!.dimension {
            case .mass:
                self.var1UnitsLabel.text = UnitMass.grams.symbol
            case .volume:
                self.var1UnitsLabel.text = UnitVolume.milliliters.symbol
                
            case .concentration:
                self.var1UnitsLabel.text = UnitConcentrationMass.molar.symbol
                
            case .regression:
                self.var1UnitsLabel.text = ""
                
            case .percentage:
                self.var1UnitsLabel.text = "%"
}

        }
        
        let var1 = self.variables?.first!
        self.var1Label.text = var1?.label.description
        self.var1Field.text = 0.0.description
        switch var1!.dimension {
        case .mass:
            self.var1UnitsLabel.text = UnitMass.grams.symbol
        case .volume:
            self.var1UnitsLabel.text = UnitVolume.milliliters.symbol
            
        case .concentration:
            self.var1UnitsLabel.text = UnitConcentrationMass.molar.symbol
            
        case .regression:
            self.var1UnitsLabel.text = ""
        case .percentage:
            self.var1UnitsLabel.text = "%"
        }
        
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    // MARK: - State Management
    func loadFromDelegate() {
    }
    
    func saveToDelegate(){
    }


    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
        let identifier = segue.identifier!
        switch identifier {
        case constants.unwindSegueIdentifier.rawValue:
            // Prepare for the segue by constructing the inputsList to be sent back
            self.inputList = [Input]()
            self.var1Field.text = self.var1Field.text?.replacingOccurrences(of: ",", with: ".")
            self.var1Field.becomeFirstResponder()
            self.var1Field.clearsOnBeginEditing = true
            let input1 = Input(fromVariable: (self.variables?.first)!, withValue: Double(self.var1Field.text!)!)
            self.inputList?.append(input1)
            if (self.variables?.count)! > 1 {
                self.var2Field.text = self.var2Field.text?.replacingOccurrences(of: ",", with: ".")

                let input2 = Input(fromVariable: (self.variables?[1])!, withValue: Double(self.var2Field.text!)!)
                self.inputList?.append(input2)
            }
            
            break
        default:
            break
        }
    }

    //MARK: - Actions 
    @IBAction func saveButtonPressed(_ sender: Any) {
    }

    @IBAction func cancelButtonPressed(_ sender: Any) {
        self.dismiss(animated: true, completion: nil)
    }
    @IBAction func varValueChanged(_ sender: UITextField) {
        sender.text = sender.text?.replacingOccurrences(of: ",", with: ".")

    }
    
}
