//
//  BrainController.swift
//  MeasurementHelper
//
//  Created by Carlos Barrera on 11/11/17.
//  Copyright © 2017 Carlos Barrera. All rights reserved.
//

import Foundation

class BrainController : NSObject{
    let brain = CalculatorBrain()
    let stats = Sigma()
    
    private func insertVariables(inputs: [Input]) {
        var payload = [String:Double]()
        for input in inputs {
            payload.updateValue(input.measure.value, forKey: input.label)
        }
        
        self.insertVariables(inputs: payload)
        
    }
    private func insertVariables(inputs: [String:Double]) {
            brain.insertConstants(inputs)
        
    }

    
    public func getResultFor(formula:[Step], inputs:[Input]) -> Double {
        self.insertVariables(inputs: inputs)
        
        for step in formula {
            brain.performOperand(symbol: step.operation)
        }
        
        return brain.result
        
    }
    public func getResultFor(formula:[Step], inputs:[String:Double]) -> Double {
        self.insertVariables(inputs: inputs)
        
        for step in formula {
            brain.performOperand(symbol: step.operation)
        }
        
        return brain.result
        
    }

    
}



