//
//  ExperimentTypeTableViewController.swift
//  MeasurementHelper
//
//  Created by Carlos Barrera on 16/11/17.
//  Copyright © 2017 Carlos Barrera. All rights reserved.
//

import UIKit
import os.log

class ExperimentTypeTableViewController: UITableViewController {

    enum constants : String {
        case cellIdentifier = "ExperimentTypeTableViewCellIdentifier"
        case createNewSessionIdentifier = "CreateNewSessionWithExperimentTypeSegueIdentifier"
        case presentQRIdentifier = "PresentQRViewControllerIdentifier"
        
    }

    
    var experiments = [Experiment]()
    var appDelegate : AppDelegate?
    var selected : Experiment?

    override func viewDidLoad() {
        super.viewDidLoad()

        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false
        appDelegate = (UIApplication.shared.delegate as! AppDelegate)

        // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
        // self.navigationItem.rightBarButtonItem = self.editButtonItem
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int {
        // #warning Incomplete implementation, return the number of sections
        return 1
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // #warning Incomplete implementation, return the number of rows
        return self.experiments.count
    }

    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: constants.cellIdentifier.rawValue, for: indexPath) as! ExperimentTypeTableViewCell

        // Configure the cell...
        cell.experimentType.text = self.experiments[indexPath.row].name

        return cell
    }

    override func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        self.selected = self.experiments[indexPath.row]
    }
    
    override func tableView(_ tableView: UITableView, editActionsForRowAt: IndexPath) -> [UITableViewRowAction]? {
        
        let exportQR = UITableViewRowAction(style: .default, title: "ExportQR"){
            action, index in
            self.selected = self.experiments[index.row]
            self.performSegue(withIdentifier: constants.presentQRIdentifier.rawValue, sender: self)
        }
        exportQR.backgroundColor = .blue
        
        let delete = UITableViewRowAction(style: .default, title: "Delete") { action, index in
            //            print("Delete pressed")
            self.experiments.remove(at: index.row)
            tableView.deleteRows(at: [index], with: .automatic)
            self.appDelegate?.experimentTypes = self.experiments
        }
        delete.backgroundColor = .orange
        
        
//        tableView.reloadData()
        return [delete, exportQR]
        
    }

    
    /*
    // Override to support conditional editing of the table view.
    override func tableView(_ tableView: UITableView, canEditRowAt indexPath: IndexPath) -> Bool {
        // Return false if you do not want the specified item to be editable.
        return true
    }
    */

    /*
    // Override to support editing the table view.
    override func tableView(_ tableView: UITableView, commit editingStyle: UITableViewCellEditingStyle, forRowAt indexPath: IndexPath) {
        if editingStyle == .delete {
            // Delete the row from the data source
            tableView.deleteRows(at: [indexPath], with: .fade)
        } else if editingStyle == .insert {
            // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
        }    
    }
    */

    /*
    // Override to support rearranging the table view.
    override func tableView(_ tableView: UITableView, moveRowAt fromIndexPath: IndexPath, to: IndexPath) {

    }
    */

    /*
    // Override to support conditional rearranging of the table view.
    override func tableView(_ tableView: UITableView, canMoveRowAt indexPath: IndexPath) -> Bool {
        // Return false if you do not want the item to be re-orderable.
        return true
    }
    */

    // MARK: - Navigation

    @IBAction func cancelButtonPressed(_ sender: UIBarButtonItem) {
        self.dismiss(animated: true, completion: nil)
    }
    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
                
        super.prepare(for: segue, sender: sender)
        let identifier = segue.identifier!
        
        switch identifier {
        case constants.presentQRIdentifier.rawValue:
            let nvc = segue.destination as! UINavigationController
            let dvc = nvc.viewControllers.first! as! QRViewerViewController
            
            let message = self.selected.prepareQRPayloadFor(item: self.selected!)
            
            //            dvc.messageString = (self.appDelegate?.currentSession.exportString())!
            dvc.messageString = message.exportString()
            break
default:
            if let cell = sender as? ExperimentTypeTableViewCell {
                let indexPath = tableView.indexPath(for: cell)
                self.selected = self.experiments[(indexPath?.row)!]
                //            print(self.selected)
            }

        }
        
//        print(sender)
        
    }

}
