//
//  QRViewerViewController.swift
//  MeasurementHelper
//
//  Created by Carlos Barrera on 23/11/17.
//  Copyright © 2017 Carlos Barrera. All rights reserved.
//

import UIKit

class QRViewerViewController: UIViewController {

    
    @IBOutlet weak var qrView: UIImageView!
    public var messageString = ""
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // Do any additional setup after loading the view.
        
        var qrCode = QRCode(messageString)
        qrCode?.size = CGSize(width: 117, height: 117)
        print("QR message length = \(messageString.count)")
        qrCode?.errorCorrection = QRCode.ErrorCorrection.Medium

        self.qrView.image = qrCode?.image
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

    // MARK: - QR Generator reference
    /*// URL
     let url = URL(string: "http://schuch.me")!
     let qrCode = QRCode(url)
     qrCode?.image
     
     // String
     let qrCode = QRCode("http://schuch.me")
     qrCode?.image
     
     // NSData
     let data = "http://schuch.me".data(using: .isoLatin1)!
     let qrCode = QRCode(data)
     qrCode.image
     */
    // MARK: - Actions
    
    @IBAction func cancelButtonPressed(_ sender: UIBarButtonItem) {
        self.dismiss(animated: true, completion: nil)
    }
    @IBAction func shareButtonPressed(_ sender: UIBarButtonItem) {
        
        let imageToShare = self.qrView.image
        let objectsToShare = [imageToShare]
        let activityVC = UIActivityViewController(activityItems: objectsToShare, applicationActivities: nil)
        
        let excludeActivities = [ UIActivityType.addToReadingList,
                                  .assignToContact,
                                  .postToFacebook,
                                  .postToWeibo,
                                  .postToTencentWeibo,
                                  .postToVimeo]
        activityVC.excludedActivityTypes = excludeActivities
        self.present(activityVC, animated: true, completion: nil)
    }
}
