//
//  Experiment.swift
//  MeasurementHelper
//
//  Created by Carlos Barrera on 3/11/17.
//  Copyright © 2017 Carlos Barrera. All rights reserved.
//

import Foundation

public class Experiment : Codable, Equatable {
    
    
//    public enum SupportedDimensions : String , Codable{
//        case mass = "mass"
//        case volume = "volume"
//        case concentration = "concentration"
//    }

    
    // What defines a Kind of experiment (valoration, % humidity, etc...
    var name = ""
    var description = ""
    var formula = [Step]()
    var variables = [Variable]()
    var valorant : Solution? = nil
    var result : Variable?
    var regressionType = false
    var formulaString : String {
        get {
            let out = formula.map({$0.operation}).joined(separator: " ")
            return out
        }
    }
   
    public class func stepsFromFormula(formula: String) -> [Step]{
        let functionSteps = formula.split(separator: " ")
        var result = [Step]()
        for (index,step) in functionSteps.enumerated() {
            let operation = String(step)
            result.append(Step(operation: operation, atIndex: index))
        }
        return result
    }

    
    // MARK: - Equatable protocol Method
    public static func ==(lhs: Experiment, rhs: Experiment) -> Bool {
        return ((rhs.description == lhs.description) && (rhs.formulaString == lhs.formulaString) && (rhs.name == lhs.name))
    }

    
}
