//
//  Round.swift
//  MeasurementHelper
//
//  Created by Carlos Barrera on 19/11/17.
//  Copyright © 2017 Carlos Barrera. All rights reserved.
//

import Foundation

struct Round : Codable{
    var inputs = [String:[Input]]()
    
    mutating func addInput(_ input: Input) {
        var inputArray = inputs[input.label] ?? [Input]()
        // if it exists we obtain it, if not, we init a new one
        //we add our input
        inputArray.append(input)
        //we store it with the new key
        self.inputs.updateValue(inputArray, forKey: input.label)
    }
    
    func getInputsForLabel(_ label: String) -> [Input] {
        return self.inputs[label] ?? [Input]()
    }
    
    func replicateCount() -> Int {
        var jointArray = [Input]()
        for (_, value) in inputs {
            jointArray.append(contentsOf: value)
        }
        let replicates = jointArray.filter({$0.shared == false}).count
        return replicates
    }
    
    
}
